using System;
using System.Collections.Generic;
using System.Text;

namespace XGAE.Framework.Services
{
    public delegate void Tick();

    /// <summary>
    /// Single entry point of control. This interface can be used by most components as a standard
    /// hook, including Brain modules.
    /// </summary>
    public interface IExecute
    {        
        /// <summary>
        /// Perform the most primitive operation and return within finite time.
        /// </summary>
        void Tick();

        /*void Delete(Interface i);
        {
            if (i != null)
            {
                i.Destroy();
            }
        }*/
    }
}
